<?php
/**
 * Plugin Color: Sets new colors for text and background.
 * 
 * @license    GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author     Christopher Smith <chris@jalakai.co.uk>
 */
 
// must be run within Dokuwiki
if(!defined('DOKU_INC')) die();

define("CHECK",0);
 
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
 
/**
 * All DokuWiki plugins to extend the parser/rendering mechanism
 * need to inherit from this class
 */
class syntax_plugin_swp extends DokuWiki_Syntax_Plugin {
 
    /**
     * return some info
     */
    function getInfo(){
        return array(
            'author' => 'Christopher Smith',
            'email'  => 'chris@jalakai.co.uk',
            'date'   => '2008-02-06',
            'name'   => 'Color Plugin',
            'desc'   => 'Changes text colour and background',
            'url'    => 'http://wiki.splitbrain.org/plugin:tutorial',
        );
    }
 
    function getType(){ return 'substition';  }
    function getAllowedTypes() { return array('formatting', 'substition', 'disabled'); }   
    function getSort(){ return 158; }
    function connectTo($mode) { $this->Lexer->addEntryPattern('<swp.*?/>',$mode,'plugin_swp'); }
    //function postConnect() { $this->Lexer->addExitPattern('/>','swi_fakty'); }
 
 
    /**
     * Handle the match
     */
    function handle($match, $state, $pos, &$handler){
        switch ($state) {
          case DOKU_LEXER_ENTER :
				$parametry=substr($match,4);
				$poz=explode(' ',$parametry);
				$params=array();
				$goal='';
				$scope='';
				foreach ($poz as $po)
				{
					preg_match( '/=.*?".*?"/',$po, $str);
					if (substr($po,0,4)=="goal")
					{
						$goal=substr($str[0],2);
						$goal=substr($goal,0,strpos($goal,'"'));
					}
					if (substr($po,0,5)=="scope")
					{
						$scope=substr($str[0],2);
						$scope=substr($scope,0,strpos($scope,'"'));
				}
					}
				return array($state,array($goal,$scope));
          case DOKU_LEXER_UNMATCHED :  return array($state, $match);
          case DOKU_LEXER_EXIT :       return array($state, '');
        }
        return array();
    }
	 
    /**
     * Create output
     */
    function render($mode, &$renderer, $data) {
        if($mode == 'xhtml'){
            list($state, $match) = $data;
            switch ($state) {
			case DOKU_LEXER_ENTER :
				list($cel,$przeszczen) = $match;
				require_once (DOKU_PLUGIN."swp/swp.php");
				////////////////////////////////////////////////////////////////
				$sciezka='data/pages';		//
				$tmp=$przeszczen;
				$nazwy=array();
				$nazwy=explode(':',$tmp);
				foreach ($nazwy as $n)
					$sciezka.='/'.$n;
				$tab=_search($sciezka);   // tablica z plikami
				$tab[]=$sciezka.'.txt';
				$tab=wyslij($tab);
				save_core($tab,$cel);
				////////////////////////////////////////////////////////////////
				$renderer->doc .= '<font style="color:#0f0;">'.goal($cel).'</font>';
			break;
              case DOKU_LEXER_UNMATCHED :
				$renderer->doc .= $match; break;
			  break;
              case DOKU_LEXER_EXIT :       break;
            }
            return true;
        }
        return false;
    }
}
?>